// mlightbox v0.1.0 fork
// https://github.com/welksonramos/mlightbox.js

;(function() {
  'use strict';
  const el = Array.from(document.querySelectorAll('[mlightbox]'));
  const currentImage = document.createElement('img');
  const lightboxPreview = document.createElement('div');
  const lightboxContent = document.createElement('div');
  const btnClose = document.createElement('button');

  function init() {
    createTemplate();
    open();
    close();
  }

  function createTemplate() {
    lightboxPreview.classList.add('preview-mlightbox');
    lightboxContent.classList.add('mlightbox-content');
    btnClose.classList.add('mlightbox-close');

    document.body.insertBefore(lightboxPreview, document.body.nextSibling);
    btnClose.insertAdjacentHTML('beforeend', '&times;');
    lightboxPreview.insertBefore(btnClose, lightboxPreview.firstChild);
    lightboxPreview.insertBefore(lightboxContent, lightboxPreview.nextSibling);
  }

  function isCurrent() {
    lightboxPreview.classList.add('mlightbox-open');
    currentImage.setAttribute('src', this.getAttribute('href'));
    lightboxContent.insertBefore(currentImage, lightboxContent.firstChild);
  }

  function open() {
    el.map(function(item) {
      item.addEventListener(
        'click',
        function(event) {event.preventDefault()},
        false)
      })

    el.map(function(item) {
      item.addEventListener('click', isCurrent, false)
    })
  }

  function close () {
    currentImage.addEventListener('click', function() {lightboxPreview.classList.remove('mlightbox-open')});
    btnClose.addEventListener('click', function() {lightboxPreview.classList.remove('mlightbox-open')});
    window.document.addEventListener('keyup', function(event) {
      if(event.keyCode == 27) {
        lightboxPreview.classList.remove('mlightbox-open');
      }
    });
  }

  init();
})();
