/*
The script is extracted into a separate file to allow for strict CSP headers.

This is a lighter version of the `st.js` file from Swiftype.

See: https://s.swiftypecdn.com/install/v1/st.js

`st.js` basically is a legacy loader for the `widget.js`.
I stripped it down to the minimum and disabled the loading of CSS files.

Some minor improvements include triggering of the search based on query params.
*/
function loadScript(url) {
    var element = document.createElement('script');
    element.type = 'text/javascript';
    element.async = true;
    element.src = url;

    var first_script = document.getElementsByTagName('script')[0];
    first_script.parentNode.appendChild(element);
  };

  function queryParam(name) {
    var reg = new RegExp('[\?&]' + name + '=([^&#]*)');
    var results = reg.exec(window.location.search);

    if (results != null) {
      return results[1] || 0;
    }
  };

  function executeCommand(name, value) {
    if(name === 'loadScript') {
      loadScript(value);
    }
  };

  window['SwiftypeObject'] = '_st';
  window[window['SwiftypeObject']] = executeCommand;

  document.addEventListener('DOMContentLoaded', function(event) {
    window.Swiftype || (window.Swiftype = {});
    window.Swiftype.disableAutocomplete = true;

    var keyword = queryParam('srch-term');

    if(keyword) {
      window.location.replace(window.location.pathname + '#stq=' + keyword);
    }
  });
