/*
JS for wip.sftpplus.com to redirect users to www.sftpplus.com.
For testing use wip.sftpplus.com/?wip
*/

(function(){
    var h = window.location.hostname
    var s = h.slice(0, 4)
    if (s == 'www.' || s == 'sftp' || s == 'loca' || s == '127.') {
        // Looks like we already are on the production site.
        // Nothing more to do.
        return
    }

    var param = 'wip';
    var production = 'https://www.sftpplus.com';

    if (getParameterByName(param) == '' && !isWIPVersion()) {
        setCookie(param, '', 1) // Cookie expires in 1 day.
    }

    if(isWIPVersion()) {
        return
    }

    // Redirect to production if we have no cookie.
    var path = window.location.pathname;
    window.location = production + path;

    function getParameterByName(name) {
        var url = window.location.href;
        name = name.replace(/[\[\]]/g, '\\$&');
        var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)');
        var results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return '';
        return decodeURIComponent(results[2].replace(/\+/g, ' '));
    }

    function setCookie(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = 'expires='+ d.toUTCString();
        document.cookie = cname + '=' + cvalue + ';' + expires + ';path=/';
    }

    function getCookie(cname) {
        let name = cname + '=';
        let ca = document.cookie.split(';');
        for(let i = 0; i < ca.length; i++) {
          let c = ca[i];
          while (c.charAt(0) == ' ') {
            c = c.substring(1);
          }
          if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
          }
        }
        return null;
    }

    // Return true if we are currently on the WIP version of the site.
    // WIP means a testing domain + explicit `wip` URL argument.
    function isWIPVersion() {
        let wip = getCookie(param);
        if (wip == '') {
            return true;
        }
        return false;
    }
}());
