# Copyright (c) 2024 Adi Roiban.
# See LICENSE for details.
"""
Helper to convert from UTF16 files generated by NSIS to UTF8.
"""
import sys

if __name__ == '__main__':  # noqa:cover
    source_path = sys.argv[1]
    destination_path = sys.argv[2]
    with open(source_path, 'rb') as source:
        content = source.read()
        content = content.decode('utf-16-le')
        with open(destination_path, 'wb') as destination:
            destination.write(content.encode('utf-8'))

    print('Convert from UTF16LE to UTF8 "{}" "{}"'.format(
        source_path, destination_path))
