# Copyright (c) 2012 Adi Roiban.
# See LICENSE for details.
"""
JSON handling package.
"""
from __future__ import absolute_import

import json

loads = json.loads


def dumps(obj, sort_keys=False, indent=None):
    """
    Use specialized `ChevahJSONEncoder` for object serialization.
    """
    # Lazy import to avoid circular imports.
    from chevah.server.json.codex import ChevahJSONEncoder
    return json.dumps(
        obj,
        cls=ChevahJSONEncoder,
        sort_keys=sort_keys,
        indent=indent,
        ensure_ascii=False,
        )
