# Copyright (c) 2015 Adi Roiban.
# See LICENSE for details.
"""
Configuration for the resources.
"""
from __future__ import absolute_import
from __future__ import unicode_literals

from zope.interface import implementer

from chevah.server.commons.constant import (
    CONFIGURATION_SECTION_RESOURCES,
    )
from chevah.server.commons.interface import (
    IResourceConfiguration,
    IResourcesConfiguration,
    )
from chevah.server.configuration.option import (
    AutoFailOptionsMixin,
    EntityConfiguration,
    TypeOptionsMixin,
    )
from chevah.server.configuration.set import SetWithTypeConfiguration


@implementer(IResourcesConfiguration)
class ResourcesConfiguration(SetWithTypeConfiguration):
    """
    See: `IResourcesConfiguration`.
    """
    SECTION_PREFIX = CONFIGURATION_SECTION_RESOURCES
    __type_interface__ = IResourceConfiguration


@implementer(IResourceConfiguration)
class _ResourceConfigurationBase(
        EntityConfiguration, TypeOptionsMixin, AutoFailOptionsMixin):
    """
    Shared attributes by all resource configurations.
    """

    SECTION_PREFIX = CONFIGURATION_SECTION_RESOURCES

    @property
    def enabled(self):
        """
        See: `IEntityConfiguration`.

        Resource are always not-enabled at startup as they are started
        on demand.
        """
        return False
