//
// This file should contain the minimum imports.
// More environment setup files should be defined via package.json.
//

// This is required to AngularMock to do it's inject magic.
// We are also reusing it as our CI marker.
global.jasmine = true
require('angular/angular.js')
require('angular-cookies/angular-cookies.js')
require('angular-route/angular-route.js')
require('angular-sanitize/angular-sanitize.js')
require('angular-mocks/angular-mocks.js')
require('@flowjs/ng-flow')

angular.module('ui.bootstrap', [])

// Load init for the side-effect to the prototypes.
require('../__init__.js')

// Make it look like we are in the browser where CONSTANTS is global.
global.CONSTANTS = require('chevah/constants.js').CONSTANTS

// Implement for jest something similar to Mocha global leak detection
var _chevah_keys_before = {}

// We fake the window.location since js-dom has a strange implementation
// that is just a void.
// You can write to it, but nothing will change.
// It is designed to be updated via the js-dom global config, but is too
// complicated for us.
delete global.window.location
global.window.location = { 'href': '' }

// Some tests just leak from external libraries, like angular.
// Create this variable to hold those variables.
global.leak_ignore = undefined

// We fake the scrollTo since JSDom does not implement it.
// Just record the last call.
global.window._current_scrollTo = [0, 0]
global.window._current_scrollBy = [0, 0]
global.window.scrollTo = function(x, y) {
    global.window._current_scrollTo = [x, y]
}
global.window.scrollBy = function(x, y) {
    global.window._current_scrollBy = [x, y]
}

// Fake scrollIntoView since it's misisng from JSDom.
global._scroll_into_view = null
HTMLUnknownElement.prototype.scrollIntoView =  function(options) {
    global._scroll_into_view = this
}

// Fake clipboard since it's missing from JSDom.
// Store the content of latest clipboard operation,
// since it's missing from JSDom.
global._clipboard_content = ''
global.navigator.clipboard = {
    'writeText': function(text) {global._clipboard_content = text},
    'readText': function() {return global._clipboard_content},
}

beforeEach(function() {
    _chevah_keys_before = Object.keys(global)
})

afterEach(function() {
    var keys_after = Object.keys(global)
    // Check for global variable leaks.
    expect(keys_after).toEqual(_chevah_keys_before)
})
