(function(exports){

exports.TrialWarningCtrl = function($window, utils, dayjs) {

    var ctrl = this

    /*
    Return the text representation of expiration date.
    Return empty if product never expires.
    Return empty is expiration was already confirmed.
    */
    ctrl._getExpirationDescription = function() {
        var timestamp = utils.constants.EXPIRATION_TIMESTAMP

        if (!timestamp) {
            // We don't have a trial version.
            // Clean any possible previous trial info.
            $window.localStorage.removeItem(
                utils.constants.PRODUCT_NAME + '_trial_confirmation')
            return ''
        }

        var confirmed = parseInt($window.localStorage.getItem(
            utils.constants.PRODUCT_NAME + '_trial_confirmation'))
        var day_seconds = 24 * 60 * 60
        var last_day = dayjs().unix() - day_seconds
        if (confirmed && confirmed > last_day) {
            // Last confirmed less than 1 day ago.
            return ''
        }

        var at_time = dayjs.unix(timestamp)
        return '%(from)s on %(datetime)s'.supplant({
            'from': at_time.fromNow(),
            'datetime': at_time.format("DD/MM/YYYY HH:mm")
        })
    }

    // We set at at init as this is enough.
    ctrl.expiration_description = ctrl._getExpirationDescription()

    /*
    Called when the evaluation notification was confirmed.
    */
    ctrl.onConfirmExpiration = function() {
        $window.localStorage.setItem(
            utils.constants.PRODUCT_NAME + '_trial_confirmation',
            dayjs().unix())
        ctrl.expiration_description = ''
    }

}

/* c8 ignore next */
}(typeof exports === 'undefined' ? this.trial_warning = {} : exports))
