(function(exports){

    exports.authenticationCtrl = function($scope, $routeParams, utils) {

    $scope.authentication = null
    $scope.template_path = null
    $scope.section_uuid = ''

    // Alias so that we can share the same SSL config between multiple
    // components.
    $scope.ssl_configuration = null

    $scope.have_configurable_pam = false

    $scope.authentication_types = [
        {'type': 'ms-chap-v2', 'name': 'MS-CHAP-V2'},
        {'type': 'ms-chap-v1', 'name': 'MS-CHAP-V1'},
        {'type': 'chap', 'name': 'CHAP'},
        {'type': 'pap', 'name': 'PAP (plain text password)'}
        ]

    $scope.__init__ = function() {
        var authentications = $scope.$parent.getAllAuthentications()
        var current_authentication = $scope.$parent._findEntity(
            authentications, $routeParams.uuid)
        var os_name = 'unknown'

        if (!current_authentication) {
            $scope.$parent.goToPage('/authentications')
            return
        }

        $scope.authentication = current_authentication
        $scope.$parent.component = current_authentication
        $scope.ssl_configuration = current_authentication

        $scope.template_path = $scope.$parent.getTemplatePath(
            'authentication', $scope.authentication.type)

        if ($scope.process.runnables && $scope.process.runnables.status) {
            os_name = $scope.process.runnables.status.os_name
        }
        if (os_name == 'linux') {
            $scope.have_configurable_pam = true
        }

        var methods = utils.constants.BIND_DN_TYPE_NAME
        $scope.bind_dn_types = []
        for (var option in methods) {
            $scope.bind_dn_types.push({'type': option, 'name': methods[option]})
        }

        $scope.is_delete_blocked = utils.isDeleteBlocked(
            current_authentication, 'authentication')

        var uuid = current_authentication.uuid
        if (uuid) {
            // Only locations that are saved on the server have runnables.
            $scope.$parent.runnable = (
                $scope.process.runnables.authentications[uuid])
            $scope.section_uuid = 'authentications/' + uuid
        }

    }

    /*
    Delete an authentication.
    */
    $scope.onDeleteAuthentication = function() {
        var category = $scope.$parent.component_categories.authentications
        category.delete($scope.authentication)
        $scope.goToPage('/authentications')
    }

}

/* c8 ignore next */
}(typeof exports === 'undefined' ? this.authenticationCtrl = {} : exports))
