(function(exports){

    exports.groupCtrl = function($scope, $routeParams, utils) {

    $scope.group = {}
    $scope.section_uuid = ''
    // Will be set to the dropwown reference.
    $scope.predefined_home_folder_dropdown = null
    $scope.show_disable_on_inactivity = true
    var container

    $scope.__init__ = function() {
        var search = $scope.getEntities('groups')
        var current_group

        if (search.length > 0) {
            current_group = $scope.$parent._findEntity(
                search, $routeParams.uuid)

            container = $scope.$parent.component_categories.groups
        }

        if (!current_group) {
            // Group is not in main configuration.
            // Search in one of the authentication methods.
            angular.forEach(
                $scope.$parent.configuration.authentications,
                function(value, key) {
                    if (current_group) {
                        // Stop searching for more groups.
                        return
                    }
                    search = $scope.getEntities(
                    'authentications/' + value.uuid + '/groups')
                    current_group = $scope.$parent._findEntity(
                        search, $routeParams.uuid)
                    container = $scope._getIdentityContainer(value, 'groups')
                    $scope.show_disable_on_inactivity = false
                })
        }

        if (!current_group) {
            // No group with this URL.
            $scope.goToPage('/groups')
            return
        }

        $scope.is_delete_blocked = utils.isDeleteBlocked(current_group, 'group')
        $scope.group = current_group
        $scope.$parent.component = current_group

        var uuid = current_group.uuid
        if (uuid) {
            $scope.section_uuid = 'groups/' + uuid
        }
    }

    /*
    Delete a group.
    */
    $scope.onDeleteGroup = function() {
        container.delete($scope.group)
        $scope.goToPage('/groups')
    }

    /*
    Set one of the predefined value via the dropdown UI.
    */
    $scope.onPredefinedPath = function(value) {
        $scope.group.home_folder_path = value
        $scope.predefined_home_folder_dropdown.hide()
    }
}

/* c8 ignore next */
}(typeof exports === 'undefined' ? this.groupCtrl = {} : exports))
