(function(exports){

exports.headerCtrl = function($scope, $window, utils) {

    var LOGIN_PAGE_URL = utils.constants.BASE_URL_PATH + '/'
    // Will be updated once the dropdown is loaded.
    $scope.admin_menu = null

    /*
    Get logged in admin's primary role name.
    */
    $scope.getAdminRoleName = function() {
        if (!$scope.configuration || !$scope.configuration.roles) {
            // Configuration not yet loaded.
            return ''
        }

        if ($scope.avatar.roles_uuid.length < 1) {
            // Avatar not yet loaded.
            return ''
        }
        var role = $scope.resolveRole($scope.avatar.roles_uuid[0])

        return role.name
    }


    /*
    Called when the current authenticated admin menu is selected with the
    "Go to admin settings" item.
    */
    $scope.onGoToCurrentAdmin = function() {
        $scope.admin_menu.hide()
        return $scope.onGoToAdministrator($scope.avatar.uuid)
    }


    /*
    Called when the back UI button is pressed.
    It is the index page of the current component page.
    */
    $scope.onGoBack = function() {
        $window.history.back()
    }


    /*
    Called when logout link is pressed.
    */
    $scope.onLogout = function() {
        /*
        Called when we got a response from the JSON-RPC.
        */
        var on_success = function(data, status) {
            // Not much to do for the UI, other than redirecting to login.
            utils.goToURL(LOGIN_PAGE_URL)
        }

        /*
        Called when we got an error from the JSON-RPC.
        */
        var on_error = function(data, status) {
            // Not much to do. Just redirect to login.
            // We might have the session expire, and then showing an error
            // doesn't help as you need to go to login anyways.
            utils.goToURL(LOGIN_PAGE_URL)
        }

        utils.jsonrpc({
            'method': 'logout',
            'params': {},
            'success': on_success,
            'error': on_error,
            'alerts': $scope.alerts
        })
    }

}

/* c8 ignore next */
}(typeof exports === 'undefined' ? this.headerCtrl = {} : exports))
