(function(exports){

exports.locationCtrl = function($scope, $routeParams, utils) {

    $scope.CACHE_BUSTER = utils.cache_buster
    $scope.location = null
    // Alias so that we can share the same SSL config between multiple
    // components.
    $scope.ssl_configuration = false
    // Toggle the option to set CA on first connection.
    $scope.ssl_no_set_on_first_connection = false
    $scope.section_uuid = ''

    var values = utils.constants.DIGEST_NAMES
    $scope.as2_signature_algorithms = []
    for (var option in values) {
        $scope.as2_signature_algorithms.push(
            {'type': option, 'name': values[option]})
    }

    var values = utils.constants.AS2_ENCRYPTION_NAME
    $scope.as2_encryption_algorithms = []
    for (var option in values) {
        $scope.as2_encryption_algorithms.push(
            {'type': option, 'name': values[option]})
    }

    var values = utils.constants.AS2_MDN_RECEIPT_NAME
    $scope.as2_mdn_receipts = []
    for (var option in values) {
        $scope.as2_mdn_receipts.push(
            {'type': option, 'name': values[option]})
    }

    var values = utils.constants.AS2_SEND_SECURITY_NAME
    $scope.as2_send_securities = []
    for (var option in values) {
        $scope.as2_send_securities.push(
            {'type': option, 'name': values[option]})
    }

    $scope.__init__ = function() {
        var all_locations = $scope.$parent.getEntities('locations')

        if (all_locations.length < 1) {
            $scope.goToPage('/')
            return
        }

        var current_location = $scope.$parent._findEntity(
            all_locations, $routeParams.uuid)

        if (!current_location) {
            $scope.$parent.goToPage('/locations')
            return
        }

        $scope.location = current_location
        $scope.$parent.component = current_location

        // Make ssl configuration available.
        $scope.ssl_configuration = current_location

        $scope.template_path = $scope.$parent.getTemplatePath(
            'location', $scope.location.type)

        var uuid = current_location.uuid
        if (uuid) {
            // Only locations that are saved on the server have runnables.
            $scope.$parent.runnable = $scope.process.runnables.locations[uuid]
            $scope.section_uuid = 'locations/' + uuid
        }

        if ($scope.location.type == utils.constants.TYPE_NAME.FTPSE) {
            // FIXME:5459:
            // For now, we don't support for Explicit FTPS, as we don't
            // have support for start TLS.
            $scope.ssl_no_set_on_first_connection = true
        }
    }

    /*
    Delete the location for which the page is currently loaded
    and then go to the locations index page.
    */
    $scope.onDeleteLocation = function() {
        var category = $scope.$parent.component_categories.locations
        category.delete($scope.location)
        $scope.goToPage('/locations')
    }

}

/* c8 ignore next */
}(typeof exports === 'undefined' ? this.locationCtrl = {} : exports))
