/*
Tests for roles controller.
*/


describe('RolesCtrl', function() {

    var scope
    var utils
    var ctrl
    var $location

    require('../app.js')
    beforeEach(angular.mock.module('app'))
    beforeEach(inject(function($injector, $rootScope, $controller) {
        /*
        Prepare the scope and controller before each test.
        */
        utils = mk.servicesUtils($injector)

        var parent_scope = $rootScope.$new();
        ctrl = $controller(
            'mainCtrl', {
            $scope: parent_scope,
            utils: utils
        })

        scope = parent_scope.$new();
        ctrl = $controller(
            'rolesCtrl', {
            $scope: scope,
            utils: utils
            })
        $location = $injector.get('$location')
        // Run an initial digest to 'settle' all watchers.
        scope.$digest()
    }))

    test(
    'onAddRole will add a new role in the cache and then go to the page ' +
    'of the new role.',
    function() {
        var new_roles = scope.$parent.new_entities['roles']

        scope.onAddRole()

        expect(new_roles.length).toBe(1)
        expect(new_roles[0]['enabled']).toBeTrue()
        expect(new_roles[0]['uuid']).toBeUndefined()
        expect(new_roles[0]['description']).toBe('')
        expect(new_roles[0]['name']).toStartWith('New Role ')
        expect($location.path()).toStartWith(
            '/roles/New Role ')
    })

})
