(function(exports){

exports.serviceCtrl = function($scope, $routeParams, utils) {

    $scope.CACHE_BUSTER = utils.cache_buster
    $scope.service = null
    $scope.section_uuid = ''
    // FIXME:2599:
    // This is the nested configuration inside the service.
    $scope.service_configuration = null
    // Use to show/hide the user autentication UI.
    $scope.has_authentications = true
    // If we have the local manager service.
    $scope.is_manager = false
    // Alias so that we can share the same SSL config between multiple
    // components.
    $scope.ssl_configuration = null
    $scope.ssl_no_set_on_first_connection = true
    // Path to markup for service specific options.
    $scope.template_path = null

    $scope.__init__ = function() {
        var all_services = $scope.$parent.getAllServices()
        var current_service = $scope.$parent._findEntity(
            all_services, $routeParams.uuid)

        if (!current_service) {
            $scope.$parent.goToPage('/services')
            return
        }

        $scope.service = current_service
        $scope.service_configuration = $scope.service.configuration
        $scope.ssl_configuration = $scope.service_configuration
        $scope.$parent.component = current_service

        var service_type = $scope.service.type
        if (service_type === 'ftpsi') {
            service_type = 'ftp'
        }

        var no_auth_protocols = utils.constants.NO_AUTHENTICATION_PROTOCOLS
        var manager_protocols = [
            utils.constants.TYPE_NAME.LOCAL_MANAGER,
            utils.constants.TYPE_NAME.LOCAL_MANAGER_UNSECURED
            ]
        $scope.has_authentications = !no_auth_protocols.contains(
            $scope.service.type)
        $scope.is_manager = manager_protocols.contains(
            $scope.service.type)

        $scope.template_path = $scope.$parent.getTemplatePath(
            'service', service_type)

        $scope.is_delete_blocked = utils.isDeleteBlocked(
            current_service, 'service')

        var uuid = current_service.uuid
        if (uuid) {
            // Only services that are saved on the server have runnables.
            $scope.$parent.runnable = $scope.process.runnables.services[uuid]
            $scope.section_uuid = 'services/' + uuid
        }
        $scope.public_account_options = getAllPublicTargetAccounts()
    }

    /*
    Return a list of application account configuration defined on the server
    which can be used as public account for the HTTP file transfer service.
    */
    var getAllPublicTargetAccounts = function() {
        var result = $scope.getAllMainApplicationAccounts()
        result.unshift({'name': 'Disabled', 'uuid': ''})
        return result
    }

    /*
    Used by the UI to detect if custom addres input should be used.
    */
    $scope.hasCustomAddress = function() {
        // If we don't have the default IPv4 or IPv6 it means we have
        // a custom address.
        return (
            ($scope.service.address != '0.0.0.0')
            && ($scope.service.address != '::')
            )
    }

    /*
    Called when service is requested to be configured with a custom
    listening address.
    */
    $scope.onCustomAddress = function() {
        // Just set any value other than the default IPv4 and IPv6.
        $scope.service.address = '192.168.0.123'
    }

    /*
    Delete a service.
    */
    $scope.onDeleteService = function() {
        var category = $scope.$parent.component_categories.services
        category.delete($scope.service)
        $scope.goToPage('/services')
    }

}

/* c8 ignore next */
}(typeof exports === 'undefined' ? this.serviceCtrl = {} : exports))
