(function(exports){

exports.transferCtrl = function($scope, $routeParams, utils) {

    $scope.transfer = null
    $scope.configuration = null
    $scope.archive_formats = utils.constants['TRANSFER_ARCHIVE_FORMATS']
    $scope.section_uuid = ''

    /*
    Called when changes_poll_interval or stable_interval are
    updated to make sure stable_interval has a valid value.
    */
    var _updateStableInterval = function() {
        if (!$scope.transfer) {
            return
        }

        if (
            $scope.transfer.stable_interval <=
            $scope.transfer.changes_poll_interval
                ) {
            $scope.transfer.stable_interval = (
                $scope.transfer.changes_poll_interval + 1)
        }
    }

    $scope.$watch('transfer.stable_interval', function(current, old) {
        _updateStableInterval()
    })

    $scope.$watch('transfer.changes_poll_interval', function(current, old) {
        _updateStableInterval()
    })

    $scope.__init__ = function() {
        var all_transfers = $scope.getAllTransfers()

        if (all_transfers.length < 1) {
            $scope.goToPage('/')
            return
        }

        var current_transfer = $scope.$parent._findEntity(
            all_transfers, $routeParams.uuid)

        if (!current_transfer) {
            $scope.$parent.goToPage('/transfers')
            return
        }

        $scope.transfer = current_transfer
        $scope.$parent.component = current_transfer

        var uuid = current_transfer.uuid
        if (uuid) {
            // Only transfers that are saved on the server have runnables.
            $scope.$parent.runnable = $scope.process.runnables.transfers[uuid]
            $scope.section_uuid = 'transfers/' + uuid
        }
    }

    /*
    Delete the transfer for which the page is currently loaded,
    then go to the transfers index page.
    */
    $scope.onDeleteTransfer = function() {
        var category = $scope.$parent.component_categories.transfers
        category.delete($scope.transfer)
        $scope.goToPage('/transfers')
    }

}

/* c8 ignore next */
}(typeof exports === 'undefined' ? this.transferCtrl = {} : exports))
